package qses.arrays;

// Adapted from 
//"Introduction to Software Testing", 
// by Ammann and Offutt, chapter 1
// (pages 12 and 16)

public class ArrayOperations {

  public static int occurrences(char[] v, char c) {
    if (v == null) {
      throw new IllegalArgumentException();
    }
    int n = 0;
    for (int i=0; i < v.length; i++) {
      if (v[i] == c) {
        n++;
      }
    }
    return n;
  }
  
  public static int numZero(int[] x) {
    // Effects: if x == null throw NullPointerException 
    // else return the number of occurrences of 0 in x
    int count = 0;
    for (int i = 1; i < x.length; i++) 
      if (x[i] == 0) 
        count++;
    return count;
  }

  public static int findLast(int[] x, int y) {
    if (x == null) 
      throw new NullPointerException();
    
    for (int i = x.length-1; i >= 0; i--) {
      if (x[i] == y) 
    	    return i; 
    }
    return -1; 
  }

  public static int lastZero (int[] x) {
    if (x == null) 
      throw new NullPointerException();
    for (int i = 0; i < x.length; i++) {
    //for (int i = x.length-1; i >= 0; i--) {
      if (x[i] == 0) return i; 
    }
    return -1; 
  }
  // test: x=[0, 1, 0]
  // Expected = 2

  public static int countPositive (int[] x){  
    if (x == null) 
      throw new NullPointerException();
    int count = 0; 
    for (int i=0; i < x.length; i++) {
      if (x[i] >= 0) count++;
    }
    return count;
  }
  // test:  x=[-4, 2, 0, 2]             
  //        Expected = 2

  public static int oddOrPos (int[] x) {  
    if (x == null) 
      throw new NullPointerException();
    int count = 0;   
    for (int i = 0; i < x.length; i++)  
    {
      if (x[i] % 2 == 1 || x[i] > 0) {  
        count++; 
      }
    }
    return count; // 5
  }
  // test:  x=[-3, -2, 0, 1, 4]           
  //        Expected = 3

}
