package qses.pwcheck;

import java.util.Scanner;

/**
 * Test program
 * @author Eduardo Marques
 *
 */
public class TestProgram {

  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    boolean quit = false;
    PasswordChecker checker = CorrectChecker.INSTANCE;
    while (!quit) {
      System.out.print("Enter a password ('q' to quit): ");
      String password = in.nextLine();
      if (password.equals("q")) {
        quit = true;
      } else {
        boolean ok = checker.isPasswordOK(password);
        System.out.printf("'%s' is OK ? %s\n", password, ok);
      }
    } 
    in.close();
  }
  
  
  public static boolean isPasswordOK(String password) {
    boolean ok = true;
    if (password == null || (password.length() < 10 || password.length() > 20)) {
      ok = false;
    } else {
      int digits = 0;
      int upperCase = 0;
      int lowerCase = 0;
      int punct = 0;
      for (int i=0; i < password.length() && ok; i++) {
        char ch = password.charAt(i);
        if (Character.isDigit(ch)) {
          digits++;
        } 
        else if (Character.isLowerCase(ch)) {
          lowerCase++;
        }
        else if (Character.isUpperCase(ch)) {
          upperCase++;
        }
        else switch (ch) {
          case ':': case ';': case ',':
          case '.': case '!': case '?': 
            punct++;
            break;
          default:
            ok = false;

        }
      }
      if (ok) {     
        ok = digits > 0 && 
            upperCase > 0 && 
            lowerCase > 0 &&
            punct <= 1;
      }
    }
    return ok;
  }

}
